unit ClickMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, Controls, Menus,
  ShellApi, iMisc, iChii, Info, ConfigMain;

const
    //  ^XNgCp(MEXEp)
    UM_NotifyTasktray = WM_APP + 1003;

type
  TClickMainForm = class(TForm)
    PopupMenu: TPopupMenu;
    MenuConfig: TMenuItem;
    MenuExit: TMenuItem;
    N1: TMenuItem;
    MenuAbout: TMenuItem;
    MenuRestart: TMenuItem;
    MenuUtility: TMenuItem;
    MenuSend2Desktop: TMenuItem;
    MenuSend2Startup: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuRestartClick(Sender: TObject);
    procedure MenuSend2DesktopClick(Sender: TObject);
    procedure MenuSend2StartupClick(Sender: TObject);
  private
    ClickHere   : TClickHereItIs;
    IsLiveTasktray: boolean;
    NotifyIcon  : TNotifyIconData;
    procedure   InitTasktray;
    procedure   FinishTasktray;
  protected
    procedure   TrayMessage(var Msg: TMsg); message UM_NotifyTasktray;
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
  ClickMainForm: TClickMainForm;

implementation

{$R *.dfm}
{$R Extra.res}

//  ---------------------------------------------------------------------------
//  RXgN^
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/qanda/delphi/d0009410.html
constructor TClickMainForm.Create(AOwner: TComponent);
begin
    inherited;
    IsLiveTaskTray := False;
end;

//  ---------------------------------------------------------------------------
//  tH[RXgN^
procedure TClickMainForm.FormCreate(Sender: TObject);
begin
    //  ^XNgCɈړ
    Application.ShowMainForm := False;
    InitTaskTray;
    //  ݒǍ
    LoadConfiguration();
    //  tbNJn
    ClickHere := TClickHereItIs.Create();
    ClickHere.Start;
end;

//  ---------------------------------------------------------------------------
//  tH[fXgN^
procedure TClickMainForm.FormDestroy(Sender: TObject);
begin
    //  tbNI
    ClickHere.Stop;
    ClickHere.Free;
    //  ^XNgCEo
    FinishTasktray;
end;

//  ---------------------------------------------------------------------------
//  EBhEbZ[W
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/qanda/delphi/d0009410.html
//  http://www.wwlnk.com/boheme/delphi/tips/tec0310.htm
//  http://www.tls.org/~akiraand/tech_01.html
procedure   TClickMainForm.TrayMessage(var Msg: TMsg);
begin
    case Msg.wParam of
        WM_RBUTTONDOWN:
            begin
                SetForegroundWindow(Handle);
                PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
            end;
        WM_LBUTTONDBLCLK:
            begin
                SetForegroundWindow(Handle);
                MenuConfig.OnClick(MenuConfig);
            end;
    end;
end;

//  ---------------------------------------------------------------------------
//  ^XNgCɃZbg
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/qanda/delphi/d0009410.html
//  http://homepage1.nifty.com/~okapon/download/delphi/tips1.html
procedure TClickMainForm.InitTasktray;
var

    TempIcon: HICON;
begin
    //  Ƀ^XNgCȂXLbv
    if IsLiveTasktray then exit;
    //  \̏
    FillChar(NotifyIcon, SizeOf(NotifyIcon), #0);
    TempIcon := LoadIcon(HInstance, 'TRAYICON');
    with NotifyIcon do
    begin
        cbSize := SizeOf(TNotifyIconData);
        Wnd    := Handle;
        uID    := 1;
        uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        uCallbackMessage := UM_NotifyTasktray;
        if (TempIcon <> 0) then
            hIcon  := TempIcon
        else
            hIcon  := Application.Icon.Handle
        ;
    end;
    //  `bvwvݒ
    StrPLCopy(NotifyIcon.szTip, ChangeFileExt(ExtractFileName(ParamStr(0)), ''), 64);
    //  ǉ
    Shell_NotifyIcon(NIM_ADD, @NotifyIcon);
    //  tOON
    IsLiveTasktray := True;
end;

//  ---------------------------------------------------------------------------
//  ^XNgC
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/qanda/delphi/d0009410.html
procedure TClickMainForm.FinishTasktray;
begin
    //  Ƀ^XNgCɂȂȂXLbv
    if not IsLiveTasktray then exit;
    //  \̏
    with NotifyIcon do
    begin
        cbSize := SizeOf(TNotifyIconData);
        Wnd := Handle;
        uID := 1;
    end;
    //  폜
    Shell_NotifyIcon(NIM_DELETE, @NotifyIcon);
    //  tOOFF
    IsLiveTasktray := False;
end;

//  ---------------------------------------------------------------------------
//  j[:I
procedure TClickMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

//  ---------------------------------------------------------------------------
//  j[:ݒ
procedure TClickMainForm.MenuConfigClick(Sender: TObject);
begin
    OpenConfigMain();
end;

//  ---------------------------------------------------------------------------
//  j[:About
procedure TClickMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//  ---------------------------------------------------------------------------
//  j[:ċN
procedure TClickMainForm.MenuRestartClick(Sender: TObject);
begin
    ShellExecute(Application.Handle,
                 nil,
                 PChar(ParamStr(0)),
                 PChar(GUID_MAIN),
                 nil,
                 SW_SHOW
                 );
    Self.Close();
end;

//  ---------------------------------------------------------------------------
//  j[:fXNgbvɃV[gJbg
procedure TClickMainForm.MenuSend2DesktopClick(Sender: TObject);
begin
    SendShortCutToDesktop(ParamStr(0));
    if not SimpleYesNo('Do You BelieveH') then ToggleDesktopNearly();
end;

//  ---------------------------------------------------------------------------
//  j[:X^[gAbvɃV[gJbg
procedure TClickMainForm.MenuSend2StartupClick(Sender: TObject);
begin
    SendShortCutToStartUp(ParamStr(0));
    if not SimpleYesNo('Do You BelieveH') then OpenStartUp();
end;

end.

