unit ConfigMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Buttons, IniFiles, iMisc, StdCtrls;

type
  TConfigMainForm = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    EditDesktopStr: TEdit;
    EditMyComputerStr: TEdit;
    EditMyNetworkStr: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label8: TLabel;
    EditWaitForCheck: TEdit;
    EditWaitForCabinet: TEdit;
    EditWaitForExplore: TEdit;
    EditWaitForOK: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
  private
    procedure   LoadConfig();
    procedure   SaveConfig();
  public

  end;

var
    ConfigMainForm: TConfigMainForm = nil;

procedure   OpenConfigMain();

implementation

{$R *.dfm}

(*
//  -----------------------------------------------------------------
    ݒʊJ
//  -----------------------------------------------------------------
*)
procedure   OpenConfigMain();
begin
    if (ConfigMainForm <> nil) then
    begin
        Application.BringToFront();
    end
    else
    begin
        ConfigMainForm := TConfigMainForm.Create(Application);
        try
            ConfigMainForm.ShowModal();
        finally
            ConfigMainForm.Free();
            ConfigMainForm := nil;
        end;
    end;
end;

(*
//  -----------------------------------------------------------------
    TEdit𐔒lp
//  -----------------------------------------------------------------
    http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=16#0223.txt
    http://www.borland.co.jp/qanda/delphi/d0003457.html
//  -----------------------------------------------------------------
*)
procedure   SetEditToNumberOnly(AEdit: TEdit; ALength: integer);
var
    WindowLongVal: integer;
begin
    //  l̂ݓ͂
    WindowLongVal := GetWindowLong(AEdit.Handle, GWL_STYLE);
    WindowLongVal := WindowLongVal or ES_NUMBER;
    SetWindowLong(AEdit.Handle, GWL_STYLE, WindowLongVal);
    //  
    PostMessage(AEdit.Handle, EM_LIMITTEXT, ALength, 0);
end;

(*
//  -----------------------------------------------------------------
    tH[RXgN^
//  -----------------------------------------------------------------
*)
procedure TConfigMainForm.FormCreate(Sender: TObject);
begin
    //  ^Cgݒ
    Self.Caption := Application.Title + ' - ' + Self.Name;
    //  lp
    SetEditToNumberOnly(EditWaitForCheck  , 3);
    SetEditToNumberOnly(EditWaitForOK     , 3);
    SetEditToNumberOnly(EditWaitForCabinet, 3);
    SetEditToNumberOnly(EditWaitForExplore, 3);
    //  ǂݍ
    LoadConfig();
end;

(*
//  -----------------------------------------------------------------
    ݒ\
//  -----------------------------------------------------------------
*)
procedure   TConfigMainForm.LoadConfig();
begin
    EditDesktopStr.Text     := ClickConfig.DeskTop;
    EditMyComputerStr.Text  := ClickConfig.MyComputer;
    EditMyNetworkStr.Text   := ClickConfig.MyNetwork;
    EditWaitForCheck.Text   := IntToStr(ClickConfig.Wait4Check);
    EditWaitForOK.Text      := IntToStr(ClickConfig.Wait4OK);
    EditWaitForCabinet.Text := IntToStr(ClickConfig.Wait4Cabinet);
    EditWaitForExplore.Text := IntToStr(ClickConfig.Wait4Explore);
end;

(*
//  -----------------------------------------------------------------
    ݒۑ
//  -----------------------------------------------------------------
*)
procedure   TConfigMainForm.SaveConfig();
begin
    //  \̂ɃZbg
    ClickConfig.DeskTop      := EditDesktopStr.Text;
    ClickConfig.MyComputer   := EditMyComputerStr.Text;
    ClickConfig.MyNetwork    := EditMyNetworkStr.Text;
    ClickConfig.Wait4Check   := StrToInt(EditWaitForCheck.Text);
    ClickConfig.Wait4OK      := StrToInt(EditWaitForOK.Text);
    ClickConfig.Wait4Cabinet := StrToInt(EditWaitForCabinet.Text);
    ClickConfig.Wait4Explore := StrToInt(EditWaitForExplore.Text);
    //  ۑ
    SaveConfiguration();
end;

//  -----------------------------------------------------------------
//  ۑ{^

procedure TConfigMainForm.BtnOKClick(Sender: TObject);
begin
    SaveConfig();
    Self.Close();
end;

//  -----------------------------------------------------------------
//  

procedure TConfigMainForm.BtnCancelClick(Sender: TObject);
begin
    Self.Close();
end;

end.

