(*
    ===========================================================================

    AboutBox

    ---------------------------------------------------------------------------

    2003/12/02  C

    ===========================================================================
*)
unit Info;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Buttons, ExtCtrls, StdCtrls;

type
  TInfoForm = class(TForm)
    AppIcon: TImage;
    Panel1: TPanel;
    Panel3: TPanel;
    lblMail: TLabel;
    lblURL: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    lblExeName: TLabel;
    lblComment: TLabel;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure lblURLClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private

  public

  end;

procedure   OpenInfoForm();

implementation

uses
    ShellApi;

{$R *.dfm}

(*
    ===========================================================================
    ShellExecutebp[
    ===========================================================================
*)
procedure   SimpleShellExecute(const FileName: string);
begin
    try
        ShellExecute(Application.MainForm.Handle, nil, PChar(FileName), nil, nil, SW_SHOW);
    except
        ;
    end;
end;

(*
    ===========================================================================
    OJ
    ===========================================================================
*)
procedure   OpenInfoForm();
var
    InfoForm: TInfoForm;
begin
    InfoForm := TInfoForm.Create(Application);
    try
        InfoForm.ShowModal();
    finally
        InfoForm.Free();
    end;
end;

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TInfoForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title + ' - ' + Self.Name;
    lblExeName.Caption := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
    AppIcon.Picture.Icon := Application.Icon;
end;

(*
    ===========================================================================
    z[y[WN
    ===========================================================================
*)
procedure TInfoForm.lblURLClick(Sender: TObject);
begin
    SimpleShellExecute(lblURL.Caption);
end;

(*
    ===========================================================================
    [[N
    ===========================================================================
*)
procedure TInfoForm.lblMailClick(Sender: TObject);
begin
    SimpleShellExecute(Format('MailTo:%s?subject=from [%s] user', [lblMail.Caption, ExtractFileName(Application.ExeName)]));
end;

(*
    ===========================================================================
    ESCŏI
    ===========================================================================
*)
procedure TInfoForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_ESCAPE then Self.Close;
end;

end.
